package com.tzld.piaoquan.recommend.server.implement.candidate;

import com.tzld.piaoquan.recommend.server.framework.candidiate.Candidate;
import com.tzld.piaoquan.recommend.server.framework.candidiate.QueueName;
import com.tzld.piaoquan.recommend.server.framework.common.User;
import com.tzld.piaoquan.recommend.server.framework.merger.IndexCandidateQueue;
import com.tzld.piaoquan.recommend.server.framework.merger.StrategyQueueConfig;
import com.tzld.piaoquan.recommend.server.framework.merger.StrategyQueueInfo;
import com.tzld.piaoquan.recommend.server.gen.recommend.RecommendRequest;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

public class Region1hHotCandidate extends IndexCandidateQueue {

    public static final String ItemType = "video";

    public Region1hHotCandidate(StrategyQueueInfo strategyQueueInfo, StrategyQueueConfig strategyQueueConfig) {
        super(strategyQueueInfo, strategyQueueConfig);
    }

    @Override
    public int addCandidateKey(Map<String, Candidate> candidates, int recallNum, User user, RecommendRequest requestData, int requestIndex, int expId) {
        int currRecall = 0;
        String region = user.getRegion();
        Map<String, Candidate> simplifiedCandidates = new ConcurrentHashMap<String, Candidate>();

        int num = recallNum / 3;


        // index key  video:queue:type=region1h:region=北京:ordering=rov
        QueueName queueName1HRegion = new QueueName(ItemType, "short_rov")
                .addMatch("type", "region1h")
                .addMatch("region", region);
        currRecall += addCandidateKey(simplifiedCandidates, queueName1HRegion, num, getStrategyQueueInfo().getQueueName());


        // index key  video:queue:type=region1h:region=北京:ordering=rov
        queueName1HRegion = new QueueName(ItemType, "rov")
                .addMatch("type", "region1h")
                .addMatch("region", region);
        currRecall += addCandidateKey(simplifiedCandidates, queueName1HRegion, num, getStrategyQueueInfo().getQueueName());

        // index key  video:queue:type=region1h:region=北京:ordering=str
        queueName1HRegion = new QueueName(ItemType, "str")
                .addMatch("type", "region1h")
                .addMatch("region", region);
        currRecall += addCandidateKey(simplifiedCandidates, queueName1HRegion, num, getStrategyQueueInfo().getQueueName());

        candidates.putAll(simplifiedCandidates);
        return currRecall;
    }

    @Override
    public String toString() {
        return "Region1hHotCandidate{" +
                "myCandidates=" + myCandidates +
                ", rankerItemsList=" + rankerItemsList +
                ", children=" + children +
                ", items=" + items +
                '}';
    }
}