package com.tzld.piaoquan.recommend.server.implement.candidate;

import com.tzld.piaoquan.recommend.server.framework.candidiate.Candidate;
import com.tzld.piaoquan.recommend.server.framework.candidiate.QueueName;
import com.tzld.piaoquan.recommend.server.framework.common.User;
import com.tzld.piaoquan.recommend.server.framework.merger.IndexCandidateQueue;
import com.tzld.piaoquan.recommend.server.framework.merger.StrategyQueueConfig;
import com.tzld.piaoquan.recommend.server.framework.merger.StrategyQueueInfo;
import com.tzld.piaoquan.recommend.server.gen.recommend.RecommendRequest;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

public class Region3hHotCandidate extends IndexCandidateQueue {

    public static final String ItemType = "video";

    public Region3hHotCandidate(StrategyQueueInfo strategyQueueInfo, StrategyQueueConfig strategyQueueConfig) {
        super(strategyQueueInfo, strategyQueueConfig);
    }

    @Override
    public int addCandidateKey(Map<String, Candidate> candidates, int recallNum, User user, RecommendRequest requestData, int requestIndex, int expId) {
        int currRecall = 0;
        String region = user.getRegion();
        Map<String, Candidate> simplifiedCandidates = new ConcurrentHashMap<>();

        int num = recallNum;


        // index key video:queue:type=region3h:region=北京:ordering=short_rov
        QueueName queueName3HRegion = new QueueName(ItemType, "short_rov")
                .addMatch("type", "region3h")
                .addMatch("region", region);
        currRecall += addCandidateKey(simplifiedCandidates, queueName3HRegion, num, getStrategyQueueInfo().getQueueName());

        candidates.putAll(simplifiedCandidates);
        return currRecall;
    }

    @Override
    public String toString() {
        return "Region3hHotCandidate{" +
                "myCandidates=" + myCandidates +
                ", rankerItemsList=" + rankerItemsList +
                ", children=" + children +
                ", items=" + items +
                '}';
    }
}